#!/bin/bash

set -e -u

OPWD=$PWD
S=/home/mase/wp/src/libHALWrapper.github
GCC_VERSION=12
target=example/hello_world
# -${GCC_VERSION}

rm -rf build
mkdir -p build
cd build
rm -f ${target}
rm -f ${target}.bin

export CC=arm-none-eabi-gcc
export CXX=arm-none-eabi-g++
export OBJCOPY=arm-none-eabi-objcopy

# export CM_CFLAGS="-march=armv7e-m -mcpu=cortex-m4 -mfpu=fpv4-sp-d16 -mfloat-abi=hard -mthumb -mabi=aapcs -save-temps -fno-exceptions -fno-stack-protector -ffreestanding -ffunction-sections -fdata-sections"
# export CM_CFLAGS="-march=armv7e-m -mcpu=cortex-m4 -mfpu=fpv4-sp-d16 -mfloat-abi=hard -mthumb -mabi=aapcs -save-temps -fno-stack-protector -ffreestanding -ffunction-sections -fdata-sections"
# export CM_CFLAGS="$CM_CFLAGS -flto"

#  -Wl,-L${S}/example/scripts -Wl,-T,${S}/example/scripts/stm32f303x8.ld
# export CM_LDFLAGS="-Wl,-nostdlib -Wl,--build-id=none -Wl,--gc-sections -nostdlib"
# export CM_LDFLAGS="$CM_LDFLAGS -flto"

#            -DCMAKE_SYSTEM_PROCESSOR=arm \
#            -DCMAKE_CROSSCOMPILING=1 \
#           -DCMAKE_SYSTEM_NAME=Generic \
#

# MCU=stm32f303x8
# MCU=stm32f072xb
# MCU=stm32f407xg
# MCU=stm32g031x8
# MCU=stm32l031x6

MCU=stm32l152x8
# MCU=stm32g441xb

export LTO="-flto -Wl,-flto"
export CM_CFLAGS="-ffunction-sections -fdata-sections -fno-exceptions -Wall"
export CM_CFLAGS="${CM_CFLAGS} -fno-stack-protector -ffreestanding"
export CM_LDFLAGS="-Wl,--gc-sections -fdevirtualize-at-ltrans -Wl,--sort-section=alignment -Wl,--just-symbols=$OPWD/symbols.map"
# " -s -Wl,-s -Wl,-u,atexit"
# " -Wl,--just-symbols=$OPWD/symbols.map"

# Debug, Release, RelWithDebInfo, MinSizeRel
cmake ${S} -DMCU=${MCU} \
           -DCMAKE_BUILD_TYPE=MinSizeRel \
           -DCMAKE_C_COMPILER=$CC \
           -DCMAKE_CXX_COMPILER=$CXX \
           -DCMAKE_C_COMPILER_WORKS=1 \
           -DCMAKE_CXX_COMPILER_WORKS=1 \
           -DBUILD_EXAMPLE=1\
           \
           -DCMAKE_C_FLAGS="$CM_CFLAGS" \
           -DCMAKE_CXX_FLAGS="$CM_CFLAGS" \
           -DCMAKE_EXE_LINKER_FLAGS="$CM_LDFLAGS" \


#        -DCMAKE_C_FLAGS="$CM_CFLAGS" \
#        -DCMAKE_CXX_FLAGS="$CM_CFLAGS" \
#        -DCMAKE_EXE_LINKER_FLAGS="$CM_LDFLAGS" \
#        -DCMAKE_SYSTEM_NAME=Generic \
#        -DCMAKE_BUILD_TYPE=Debug \
#

make -j$(nproc)
# VERBOSE=1
# VERBOSE=0

${OBJCOPY} -S -O ihex ${target} ${target}.hex
${OBJCOPY} -S --strip-unneeded --strip-debug -O binary ${target} ${target}.bin
readelf ${target} -a > ${target}.list

ls -l ${target}.bin ..


#--- fin ----------------------------------------------------------------------
